VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3030
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   3030
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   510
      Top             =   2550
   End
   Begin MSWinsockLib.Winsock Winsock1 
      Left            =   60
      Top             =   2550
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   990
      TabIndex        =   0
      Top             =   1140
      Width           =   1755
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ActiveVB DHCP Discovery VBC
' Converted from  http://www.indented.co.uk/2010/02/17/dhcp-discovery/
' Author: Frank Schler

' http://www.mvps.org/emorcillo/download/vb6/tl_ole.zip -> olelib.tlb
' reference to the "Edanmos OLE interfaces & functions v1.81" for IStream
' reference to the "Microsoft VBScript Regular Expressions 5.5" for RegEx

'<#
'  Net-DhcpDiscover.ps1

'  Author: Chris Dent
'  Date :  16/02/2010

'  A script To send a DHCPDISCOVER request And report On DHCPOFFER
'  responses returned by all DHCP Servers On the current subnet.

'  DHCP Packet Format (RFC 2131 - http://www.ietf.org/rfc/rfc2131.txt)

'  0                   1                   2                   3
'  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
'  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
'  |     op (1)    |   htype (1)   |   hlen (1)    |   hops (1)    |
'  +---------------+---------------+---------------+---------------+
'  |                            xid (4)                            |
'  +-------------------------------+-------------------------------+
'  |           secs (2)            |           flags (2)           |
'  +-------------------------------+-------------------------------+
'  |                          ciaddr  (4)                          |
'  +---------------------------------------------------------------+
'  |                          yiaddr  (4)                          |
'  +---------------------------------------------------------------+
'  |                          siaddr  (4)                          |
'  +---------------------------------------------------------------+
'  |                          giaddr  (4)                          |
'  +---------------------------------------------------------------+
'  |                                                               |
'  |                          chaddr  (16)                         |
'  |                                                               |
'  |                                                               |
'  +---------------------------------------------------------------+
'  |                                                               |
'  |                          sname   (64)                         |
'  +---------------------------------------------------------------+
'  |                                                               |
'  |                          file    (128)                        |
'  +---------------------------------------------------------------+
'  |                                                               |
'  |                          options (variable)                   |
'  +---------------------------------------------------------------+

'   FIELD      OCTETS       DESCRIPTION
'   -----      ------       -----------

'   op            1  Message op code / message type.
'                    1 = BOOTREQUEST, 2 = BOOTREPLY
'   htype         1  Hardware address type, see ARP section In "Assigned
'                    Numbers" RFC; e.g., '1' = 10mb ethernet.
'   hlen          1  Hardware address length (e.g.  '6' for 10mb
'                    ethernet).
'   hops          1  Client sets To zero, optionally used by relay agents
'                    when booting via a relay agent.
'   xid           4  Transaction ID, a random number chosen by the
'                    client, used by the client And server to associate
'                    messages And responses between a client And a
'                    server.
'   secs          2  Filled In by client, seconds elapsed since client
'                    began address acquisition Or renewal process.
'   flags         2  Flags (see figure 2).
'   ciaddr        4  Client IP address; only filled in if client Is in
'                    BOUND, RENEW Or REBINDING state And can respond
'                    to ARP requests.
'   yiaddr        4  'your' (client) IP address.
'   siaddr        4  IP address of next server to use in bootstrap;
'                    returned in DHCPOFFER, DHCPACK by server.
'   giaddr        4  Relay agent IP address, used in booting via a
'                    relay agent.
'   chaddr       16  Client hardware address.
'   sname        64  Optional server host name, null terminated string.
'   file        128  Boot file name, null terminated string; "generic"
'                    name Or null In DHCPDISCOVER, fully qualified
'                    directory-path name in DHCPOFFER.
'   options     var  Optional parameters field.  See the options
'                    documents for a list of defined options.
'#>

Private Type DhcpPacketOption
    OptionCode As Byte
    OptionName As String
    Length As Byte
    OptionValue As String
End Type

Private Type DhcpPacket
    Op As String
    HType As String
    HLen As Byte
    Hops As Byte
    XID As Double
    Secs As Long
    Flags As String
    CIAddr As String
    YIAddr As String
    SIAddr As String
    GIAddr As String
    CHAddr As String
    SName As String
    File As String
    MagicCookie As String
    Options() As DhcpPacketOption
End Type

' ----==== OLE32 API Deklarationen ====----
Private Declare Function CreateStreamOnHGlobal Lib "ole32.dll" ( _
                         ByRef hGlobal As Any, _
                         ByVal fDeleteOnRelease As Long, _
                         ByRef ppstm As Any) As Long

' ----==== KERNEL32 API Deklarationen ====----
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)
                    

' Length of time (in seconds) to spend waiting for Offers
Private Const DiscoverTimeout As Long = 10

Private Sub Command1_Click()

    Dim Message() As Byte

    Message = New_DhcpDiscoverPacket

    Winsock1.Close
    Winsock1.Protocol = sckUDPProtocol
    Winsock1.RemoteHost = "0.0.0.0"
    Winsock1.RemotePort = 68
    Winsock1.Bind 68

    Winsock1.RemoteHost = "255.255.255.255"
    Winsock1.RemotePort = 67
    Winsock1.SendData Message

    Winsock1.RemoteHost = "0.0.0.0"
    Winsock1.RemotePort = 0

    Timer1.Enabled = True

End Sub

Private Sub Form_Load()

    Timer1.Enabled = False
    Timer1.Interval = DiscoverTimeout * 1000
    Winsock1.Close

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Winsock1.Close

End Sub

Private Sub Timer1_Timer()

    Timer1.Enabled = False
    Winsock1.Close
    
    Debug.Print
    Debug.Print "DiscoverTimeout"
    Debug.Print "Ready"

End Sub

' ----==== Hilfsfunktionen ====----

Private Function SignedIntegerToUnsigned(ByVal theValue As Integer) As Long
    SignedIntegerToUnsigned = (theValue And &HFFFF&)
End Function

Private Function SignedLongToUnsigned(ByVal theValue As Long) As Double
    If (theValue And &H80000000) Then
        SignedLongToUnsigned = theValue + 4294967296#
    Else
        SignedLongToUnsigned = theValue
    End If
End Function

Private Function Math_Pow(ByVal x As Double, ByVal y As Double) As Double
    Math_Pow = x ^ y
End Function

Private Function JoinByteArray(ByRef bArray() As Byte, Optional ByVal Delimiter As _
    String = vbNullString) As String

    Dim lItem As Long
    Dim lIndex As Long
    Dim sRet As String

    lItem = UBound(bArray)

    For lIndex = 0 To lItem

        If lIndex < lItem Then

            sRet = sRet & CStr(bArray(lIndex)) & Delimiter

        Else

            sRet = sRet & CStr(bArray(lIndex))

        End If

    Next lIndex

    JoinByteArray = sRet

End Function

Private Function JoinCharByteArray(ByRef bArray() As Byte, Optional ByVal Delimiter _
    As String = vbNullString) As String

    Dim lItem As Long
    Dim lIndex As Long
    Dim sRet As String

    lItem = UBound(bArray)

    For lIndex = 0 To lItem
        
        If bArray(lIndex) = 0 Then bArray(lIndex) = 32
        
        If lIndex < lItem Then

            sRet = sRet & ChrW$(bArray(lIndex)) & Delimiter

        Else

            sRet = sRet & ChrW$(bArray(lIndex))

        End If

    Next lIndex

    JoinCharByteArray = sRet

End Function

Private Function BitConvToString(ByRef bArray() As Byte) As String

    Dim lItem As Long
    Dim lIndex As Long
    Dim sRet As String

    lItem = UBound(bArray)

    For lIndex = lItem To 0 Step -1

        If lIndex > 0 Then

            sRet = sRet & Format$(Hex$(bArray(lIndex)), "00") & "-"

        Else

            sRet = sRet & Format$(Hex$(bArray(lIndex)), "00")

        End If

    Next lIndex

    BitConvToString = sRet

End Function

' ----==== Ende Hilfsfunktionen ====----

Private Function Read_DhcpPacket(ByRef Packet() As Byte) As DhcpPacket

    Dim Reader As IStream
    Dim DhcpResponse As DhcpPacket
    Dim bData As Byte
    Dim UInt16 As Integer
    Dim UInt32 As Long
    Dim TmpArr(0 To 3) As Byte
    Dim Buffer() As Byte
    Dim MacAddrBytes() As Byte
    Dim lStreamLen As Long
    Dim lCount As Long
    Dim i As Long
    Dim Value As Double

    lStreamLen = UBound(Packet)

    If CreateStreamOnHGlobal(Packet(0), False, Reader) = 0 Then

        ' Get And translate the Op code
        Call Reader.Read(bData, 1)

        If bData = 1 Then

            DhcpResponse.Op = "BootRequest"

        Else

            DhcpResponse.Op = "BootResponse"

        End If

        Debug.Print "DhcpResponse.Op = " & DhcpResponse.Op

        Call Reader.Read(bData, 1)
        If bData = 1 Then DhcpResponse.HType = "Ethernet"
        Debug.Print ("DhcpResponse.HType = " & DhcpResponse.HType)

        Call Reader.Read(bData, 1)
        DhcpResponse.HLen = bData
        Debug.Print ("DhcpResponse.HLen = " & CStr(DhcpResponse.HLen))

        Call Reader.Read(bData, 1)
        DhcpResponse.Hops = bData
        Debug.Print ("DhcpResponse.Hops = " & CStr(DhcpResponse.Hops))

        Call Reader.Read(UInt32, 4)
        DhcpResponse.XID = SignedLongToUnsigned(UInt32)
        Debug.Print ("DhcpResponse.XID = " & CStr(DhcpResponse.XID))

        Call Reader.Read(UInt16, 2)
        DhcpResponse.Secs = SignedIntegerToUnsigned(UInt16)
        Debug.Print ("DhcpResponse.Secs = " & CStr(DhcpResponse.Secs))

        ' Broadcast Is the only flag that can be present, the other bits are reserved
        Call Reader.Read(UInt16, 2)
        If CBool(SignedIntegerToUnsigned(UInt16) And 128) Then DhcpResponse.Flags = "Broadcast"
        Debug.Print ("DhcpResponse.Flags = " & DhcpResponse.Flags)

        Call Reader.Read(TmpArr(0), 4)
        DhcpResponse.CIAddr = JoinByteArray(TmpArr, ".")
        Debug.Print ("DhcpResponse.CIAddr = " & DhcpResponse.CIAddr)

        Call Reader.Read(TmpArr(0), 4)
        DhcpResponse.YIAddr = JoinByteArray(TmpArr, ".")
        Debug.Print ("DhcpResponse.YIAddr = " & DhcpResponse.YIAddr)

        Call Reader.Read(TmpArr(0), 4)
        DhcpResponse.SIAddr = JoinByteArray(TmpArr, ".")
        Debug.Print ("DhcpResponse.SIAddr = " & DhcpResponse.SIAddr)

        Call Reader.Read(TmpArr(0), 4)
        DhcpResponse.GIAddr = JoinByteArray(TmpArr, ".")
        Debug.Print ("DhcpResponse.GIAddr = " & DhcpResponse.GIAddr)

        ReDim Preserve MacAddrBytes(15)
        Call Reader.Read(MacAddrBytes(0), 16)
        ReDim Preserve MacAddrBytes(5)
        DhcpResponse.CHAddr = Replace$(BitConvToString(MacAddrBytes), "-", ":")
        Debug.Print ("DhcpResponse.CHAddr = " & DhcpResponse.CHAddr)

        ReDim Buffer(0 To 63)
        Call Reader.Read(Buffer(0), 64)
        DhcpResponse.SName = Trim$(JoinCharByteArray(Buffer))
        Debug.Print ("DhcpResponse.SName = " & DhcpResponse.SName)

        ReDim Buffer(0 To 127)
        Call Reader.Read(Buffer(0), 128)
        DhcpResponse.File = Trim$(JoinCharByteArray(Buffer))
        Debug.Print ("DhcpResponse.File = " & DhcpResponse.File)

        Call Reader.Read(TmpArr(0), 4)
        DhcpResponse.MagicCookie = JoinByteArray(TmpArr, " ")
        Debug.Print ("DhcpResponse.MagicCookie = " & DhcpResponse.MagicCookie)

        lCount = 0

        ' Start reading Options
        While Reader.Seek(ByVal 0, STREAM_SEEK_CUR) * 10000 < lStreamLen

            ReDim Preserve DhcpResponse.Options(Count + 1)

            Call Reader.Read(bData, 1)
            DhcpResponse.Options(Count).OptionCode = bData
            DhcpResponse.Options(Count).OptionName = ""
            DhcpResponse.Options(Count).Length = 0
            DhcpResponse.Options(Count).OptionValue = ""

            If DhcpResponse.Options(Count).OptionCode <> 0 And _
                DhcpResponse.Options(Count).OptionCode <> 255 Then

                Call Reader.Read(bData, 1)
                DhcpResponse.Options(Count).Length = bData

            End If

            Select Case DhcpResponse.Options(Count).OptionCode

            Case 0
                DhcpResponse.Options(Count).OptionName = "PadOption"

            Case 1
                DhcpResponse.Options(Count).OptionName = "SubnetMask"

                Call Reader.Read(TmpArr(0), 4)
                DhcpResponse.Options(Count).OptionValue = JoinByteArray(TmpArr, ".")

            Case 3
                DhcpResponse.Options(Count).OptionName = "Router"

                Call Reader.Read(TmpArr(0), 4)
                DhcpResponse.Options(Count).OptionValue = JoinByteArray(TmpArr, ".")

            Case 6
                DhcpResponse.Options(Count).OptionName = "DomainNameServer"

                For i = 0 To DhcpResponse.Options(Count).Length / 4

                    Call Reader.Read(TmpArr(0), 4)

                    If i < DhcpResponse.Options(Count).Length / 4 Then

                        DhcpResponse.Options(Count).OptionValue = _
                            DhcpResponse.Options(Count).OptionValue & _
                            JoinByteArray(TmpArr, ".") & " / "

                    Else

                        DhcpResponse.Options(Count).OptionValue = _
                            DhcpResponse.Options(Count).OptionValue & _
                            JoinByteArray(TmpArr, ".")

                    End If

                Next

            Case 15
                DhcpResponse.Options(Count).OptionName = "DomainName"
                ReDim Buffer(0 To DhcpResponse.Options(Count).Length - 1)
                Call Reader.Read(Buffer(0), DhcpResponse.Options(Count).Length)
                DhcpResponse.Options(Count).OptionValue = JoinCharByteArray(Buffer)

            Case 51
                DhcpResponse.Options(Count).OptionName = "IPAddressLeaseTime"
                ' Read as Big Endian
                Call Reader.Read(TmpArr(0), 4)
                Value = (CDbl(TmpArr(0)) * Math_Pow(256, 3)) + (CDbl(TmpArr(1)) * _
                    Math_Pow(256, 2)) + (CDbl(TmpArr(2)) * 256) + CDbl(TmpArr(3))
                DhcpResponse.Options(Count).OptionValue = CStr(Value / 86400) & " Days"

            Case 53
                DhcpResponse.Options(Count).OptionName = "DhcpMessageType"
                Call Reader.Read(bData, 1)

                Select Case bData

                Case 1
                    DhcpResponse.Options(Count).OptionValue = "DHCPDISCOVER"

                Case 2
                    DhcpResponse.Options(Count).OptionValue = "DHCPOFFER"

                Case 3
                    DhcpResponse.Options(Count).OptionValue = "DHCPREQUEST"

                Case 4
                    DhcpResponse.Options(Count).OptionValue = "DHCPDECLINE"

                Case 5
                    DhcpResponse.Options(Count).OptionValue = "DHCPACK"

                Case 6
                    DhcpResponse.Options(Count).OptionValue = "DHCPNAK"

                Case 7
                    DhcpResponse.Options(Count).OptionValue = "DHCPRELEASE"

                End Select

            Case 54
                DhcpResponse.Options(Count).OptionName = "DhcpServerIdentifier"
                Call Reader.Read(TmpArr(0), 4)
                DhcpResponse.Options(Count).OptionValue = JoinByteArray(TmpArr, ".")

            Case 58
                DhcpResponse.Options(Count).OptionName = "RenewalTime"
                ' Read as Big Endian
                Call Reader.Read(TmpArr(0), 4)
                Value = (CDbl(TmpArr(0)) * Math_Pow(256, 3)) + (CDbl(TmpArr(1)) * _
                    Math_Pow(256, 2)) + (CDbl(TmpArr(2)) * 256) + CDbl(TmpArr(3))
                DhcpResponse.Options(Count).OptionValue = CStr(Value / 86400) & " Days"

            Case 59
                DhcpResponse.Options(Count).OptionName = "RebindingTime"
                ' Read as Big Endian
                Call Reader.Read(TmpArr(0), 4)
                Value = (CDbl(TmpArr(0)) * Math_Pow(256, 3)) + (CDbl(TmpArr(1)) * _
                    Math_Pow(256, 2)) + (CDbl(TmpArr(2)) * 256) + CDbl(TmpArr(3))
                DhcpResponse.Options(Count).OptionValue = CStr(Value / 86400) & " Days"

            Case 255
                DhcpResponse.Options(Count).OptionName = "EndOption"

            Case Else

                ' For all options which are not decoded here
                DhcpResponse.Options(Count).OptionName = "NoOptionDecode"
                ReDim Buffer(0 To DhcpResponse.Options(Count).Length - 1)
                Call Reader.Read(Buffer(0), DhcpResponse.Options(Count).Length)
                DhcpResponse.Options(Count).OptionValue = JoinByteArray(Buffer, " ")

            End Select

            If DhcpResponse.Options(Count).OptionCode <> 0 Then

                Debug.Print DhcpResponse.Options(Count).OptionName & " = " & _
                    DhcpResponse.Options(Count).OptionValue

            End If

            lCount = lCount + 1

        Wend

    End If

    Read_DhcpPacket = DhcpResponse

End Function

' Build a DHCPDISCOVER packet to send
Private Function New_DhcpDiscoverPacket(Optional ByVal MacAddressString = _
    "AA:BB:CC:DD:EE:FF") As Byte()

    Dim x As Long
    Dim y As Long
    Dim RegEx As New RegExp
    Dim XID(0 To 3) As Byte
    Dim DhcpDiscover(0 To 242) As Byte
    Dim MacAddress(0 To 5) As Byte
    
    ' Generate a Transaction ID for this request
    Randomize

    For x = 0 To 3

        XID(x) = CByte(Rnd * 255)

    Next x

    ' Drop any characters which might be used to delimit the string
    RegEx.Global = True
    RegEx.Pattern = "[^a-zA-Z0-9]"
    MacAddressString = RegEx.Replace(MacAddressString, vbNullString)

    ' Convert and Reverse the MAC Address String into a Byte Array
    y = 5

    For x = 1 To 12 Step 2

        MacAddress(y) = CByte(Val("&H" & Mid$(MacAddressString, x, 2)))
        y = y - 1

    Next x

    ' Copy the Transaction ID Bytes into the array
    Call CopyMemory(DhcpDiscover(4), XID(0), 4)

    ' Copy the MacAddress Bytes into the array
    Call CopyMemory(DhcpDiscover(28), MacAddress(0), 6)

    ' Set the OP Code to BOOTREQUEST
    DhcpDiscover(0) = 1

    ' Set the Hardware Address Type to Ethernet
    DhcpDiscover(1) = 1

    ' Set the Hardware Address Length (number of bytes)
    DhcpDiscover(2) = 6

    ' Set the Broadcast Flag
    DhcpDiscover(10) = 128

    ' Set the Magic Cookie values
    DhcpDiscover(236) = 99
    DhcpDiscover(237) = 130
    DhcpDiscover(238) = 83
    DhcpDiscover(239) = 99

    ' Set the DHCPDiscover Message Type Option
    DhcpDiscover(240) = 53
    DhcpDiscover(241) = 1
    DhcpDiscover(242) = 1

    New_DhcpDiscoverPacket = DhcpDiscover
    
End Function

Private Sub Winsock1_DataArrival(ByVal bytesTotal As Long)

    Dim ReceiveBuffer() As Byte

    If bytesTotal > 0 Then

        ReDim ReceiveBuffer(bytesTotal)

        Winsock1.GetData ReceiveBuffer

        Debug.Print
        Debug.Print ("BytesReceived")
        Debug.Print ("****************************************************")

        Call Read_DhcpPacket(ReceiveBuffer)

    End If

End Sub

